SystemOrganization addCategory: #'EsAndEm-Tests'!
SystemOrganization addCategory: #'EsAndEM-Core'!

!CompiledMethod methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 10:26'!
serializeWith: aSerializer
	aSerializer serializeExternal: self! !

!Boolean methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:08'!
materializeWith: aMaterializer
	^ self! !

!Boolean methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:08'!
serializeWith: aSerializer
	aSerializer serializeSingleton: self! !

!Integer methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:34'!
materializeWith: aMaterializer
	^ self! !

!Integer methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 16:09'!
serializeWith: aSerializer
	aSerializer serializeInteger: self! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 7/12/2010 21:42'!
closure: aBlockClosure
	closureOrNil := aBlockClosure! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:54'!
materializeWith: aMaterializer
	^ aMaterializer materializeContext: self! !

!MethodContext methodsFor: '*esandem-dispatch' stamp: 'cwp 9/8/2008 07:44'!
serializeWith: aSerializer
	^ aSerializer serializeMethodContext: self! !

!Float methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:32'!
materializeWith: aMaterializer
	^ self! !

!Float methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 19:51'!
serializeWith: aSerializer
	^ aSerializer serializeFloat: self! !

!Dictionary methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:42'!
materializeWith: aMaterializer
	^ aMaterializer materializeDictionary: self! !

!Dictionary methodsFor: '*esandem-dispatch' stamp: 'cwp 9/2/2008 22:26'!
serializeWith: aSerializer
	^ aSerializer serializeDictionary: self! !

!Symbol methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 00:04'!
serializeWith: aSerializer
	aSerializer serializeSymbol: self! !

!String methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:31'!
materializeWith: anObject
	^ self! !

TestCase subclass: #SMSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/2/2008 00:30'!
assertEqualityOf: expected
	^ self 
		assertEquivalenceOf: expected 
		with: [:actual | actual = expected]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/5/2008 07:55'!
assertEquivalenceOf: expected with: aBlock
	self 
		examineResultOf: expected 
		with: 
			[:actual | 
			self assert: (aBlock value: actual)]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 8/31/2008 23:00'!
assertIdentityOf: expected
	^ self
		assertEquivalenceOf: expected
		with: [:actual | actual == expected]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/23/2008 21:03'!
createSubcontinuation
	| subcontinuation |
	subcontinuation := ALSubcomputation do: 
		[ : p | 
		self 
			doSubcomp: 3
			with: [ p escape: [ : k | k ] ] ].
	^ subcontinuation! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/19/2008 08:01'!
doSubcomp: anInteger with: aBlock
	^ anInteger = 0
		ifTrue: aBlock
		ifFalse: [(self doSubcomp: anInteger - 1 with: aBlock) + 1]! !

!SMSerializationTest methodsFor: 'support' stamp: 'cwp 9/8/2008 21:17'!
examineResultOf: expected with: aBlock
	| actual archive |
	archive := expected serialize.
	actual := archive materialize.
	aBlock value: actual! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 19:13'!
testArchive
	| archive |
	archive := 3 serialize.
	self assert: archive materialize = 3! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 20:43'!
testArray
	self assertEqualityOf: #(1 'two' 3.0)! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:24'!
testByte
	self assertEqualityOf: 42! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 07:09'!
testBytesObject
	self assertEqualityOf: UUID new! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 23:02'!
testClass
	self assertIdentityOf: self class! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/23/2008 21:08'!
testCompiledMethod
	self assertIdentityOf: thisContext method.
	! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:57'!
testCyclicalReferenceArray
	| object |
	object := Array new: 1.
	object at: 1 put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual first == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:06'!
testCyclicalReferenceDictionary
	| object |
	object := Dictionary new: 1.
	object at: #one put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | (actual at: #one) == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:16'!
testCyclicalReferenceObject
	| object |
	object := ValueHolder new.
	object contents: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual contents == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:58'!
testCyclicalReferenceSet
	| object |
	object := Set new: 1.
	object add: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual anyOne == actual]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:22'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3;
		yourself.
	self assertEqualityOf: dict! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/26/2010 20:19'!
testDigest
	| archive |
	archive := 3 serialize.
	self assert: archive digest = '9842926af7ca0a8cca12604f945414f07b01e13d'! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/26/2010 10:22'!
testExternalObject
	| object |
	object := SMObjectWithExternalState new.
	self 
		assertEquivalenceOf: object
		with: 
			[:actual |
			actual alpha ~~ object alpha
				and: [actual beta value == object beta value]]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testFalse
	self assertIdentityOf: false! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:50'!
testFloat
	self assertEqualityOf: 3.4! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargeNegativeInteger
	self assertEqualityOf: -65536! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargePositiveInteger
	self assertEqualityOf: 65536! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:15'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:59'!
testMultiString
	| ws |
	ws := WideString fromString: 'abc'.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testNil
	self assertIdentityOf: nil! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 01:13'!
testObject
	self 
		assertEquivalenceOf: self 
		with: 
			[:actual |
			actual class = self class
				and: [actual selector = self selector]]! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/13/2008 00:21'!
testOrderedCollection
	self assertEqualityOf: OrderedCollection new! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:06'!
testSet
	self assertEqualityOf: #(1 'two' 3.0) asSet! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallNegativeInteger
	self assertEqualityOf: -300! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallPositiveInteger
	self assertEqualityOf: 300! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testString
	self assertEqualityOf: 'abc'.! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 00:04'!
testSymbol
	self assertIdentityOf: #one! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:26'!
testTrue
	self assertIdentityOf: true! !

!SMSerializationTest methodsFor: 'tests' stamp: 'cwp 7/14/2010 11:04'!
testVariablePointerObject
	| expected |
	expected := (SparseLargeTable new: 3)
		at: 1 put: $a;
		at: 2 put: $b;
		at: 3 put: $c;
		yourself.

	self 
		assertEquivalenceOf: expected 
		with: 
			[:actual |
			actual class = expected class
				and: [actual = expected]]! !

!Object methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 11:42'!
encodeWith: anEncoder
	anEncoder encodeObject: self! !

!Object methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 11:45'!
materializeWith: aMaterializer
	^ aMaterializer materializeObject: self! !

!Object methodsFor: '*esandem-public' stamp: 'cwp 8/23/2010 22:32'!
serialize
	^ SMArchive with: self! !

!Object methodsFor: '*esandem-dispatch' stamp: 'cwp 9/2/2008 00:35'!
serializeWith: aSerializer
	aSerializer serializeObject: self! !

Object subclass: #SMArchive
	instanceVariableNames: 'bytes external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMArchive class methodsFor: 'instance creation' stamp: 'cwp 8/26/2010 10:02'!
bytes: aByteArray external: anArray
	^ self basicNew
		initializeWithBytes: aByteArray external: anArray;
		yourself! !

!SMArchive class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
with: anObject
	| ext stream |
	stream := (ByteArray new: 100) writeStream.
	ext := SMSerializer serialize: anObject on: stream.
	^ self bytes: stream contents external: ext! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 11/4/2008 00:04'!
base64
	^ (Base64MimeConverter mimeEncode: self bytes readStream) contents! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2008 23:57'!
bytes
	^ bytes! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 9/8/2008 21:32'!
digest
	| sha |
	sha := SecureHashAlgorithm new.
	^ (sha hashMessage: bytes) printStringHex asLowercase! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:01'!
external
	^ external! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:02'!
initializeWithBytes: aByteArray external: anArray
	self initialize.
	bytes := aByteArray.
	external := anArray! !

!SMArchive methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:01'!
materialize
	^ (SMMaterializer on: bytes readStream)
		external: external;
		materialize! !

Object subclass: #SMDecoder
	instanceVariableNames: 'materializer stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMDecoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 21:41'!
materializer: aMaterializer stream: aStream
	^ self basicNew
		initializeWithMaterializer: aMaterializer stream: aStream;
		yourself! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 20:04'!
decode
	| type |
	type := self getType.
	type < 242 ifTrue: [^ type].
	type = 255 ifTrue: [^ self decodeArrow].
	type = 254 ifTrue: [^ self decodeExternal].
	type = 253 ifTrue: [^ self decodeClass].
	type = 252 ifTrue: [^ self decodeObject].
	type = 251 ifTrue: [^ self decodeUtf8String].
	type = 250 ifTrue: [^ self decodeUtf16String].
	type = 249 ifTrue: [^ self decodeSymbol].
	type = 248 ifTrue: [^ self decodeLargeNegativeInteger].
	type = 247 ifTrue: [^ self decodeSmallNegativeInteger].
	type = 246 ifTrue: [^ self decodeSmallPositiveInteger].
	type = 245 ifTrue: [^ self decodeLargePositiveInteger].
	type = 244 ifTrue: [^ self decodeFloat].
	type = 243 ifTrue: [^ self decodeLibrary].
	type = 242 ifTrue: [^ self decodeCustom].
! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 11:48'!
decodeArray
	^ Array new: materializer materialize! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:05'!
decodeArrow
	^ SMArrow with: materializer materialize! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:32'!
decodeByte
	^ self getByte! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:37'!
decodeClass
	| name |
	name := materializer materialize.
	^ Smalltalk at: name! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:54'!
decodeContext
	| method |
	method := materializer materialize.
	^ MethodContext newForMethod: method.! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 12:40'!
decodeDictionary
	^ Dictionary new
! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:43'!
decodeExternal
	^ SMExternal with: materializer materialize! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:45'!
decodeFloat
	^ self getFloat! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:46'!
decodeLargeNegativeInteger
	| size |
	size := materializer materialize.
	^ (self getIntegerOfSize: size) negated! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 12:49'!
decodeLargePositiveInteger
	| size |
	size := materializer materialize.
	^ self getIntegerOfSize: size! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 19:57'!
decodeLibrary
	| type |
	type := materializer materialize.
	type = 1 ifTrue: [^ nil].
	type = 2 ifTrue: [^ true].
	type = 3 ifTrue: [^ false].
	type = 4 ifTrue: [^ self decodeArray].
	type = 5 ifTrue: [^ self decodeBag].
	type = 6 ifTrue: [^ self decodeByteArray].
	type = 7 ifTrue: [^ self decodeDictionary].
	type = 8 ifTrue: [^ self decodeIdentityDictionary].
	type = 9 ifTrue: [^ self decodeInterval].
	type = 10 ifTrue: [^ self decodeOrderedCollection].
	type = 11 ifTrue: [^ self decodeSet].
	self error: 'unrecognized library type'! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 14:15'!
decodeObject
	| theClass object tmp |
	object := Object new.
	materializer addArrow: object.
	theClass := materializer materialize.
	tmp := theClass isVariable 
		ifTrue: [ theClass new: materializer materialize ]
		ifFalse: [ theClass basicNew ].
	object become: tmp.
	^ object ! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 12:28'!
decodeSet
	^ Set new! !

!SMDecoder methodsFor: 'decoding - library' stamp: 'cwp 8/26/2010 13:07'!
decodeSingleton
	^ self getSingleton! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:10'!
decodeSmallNegativeInteger
	^ self getSmallInteger negated! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:10'!
decodeSmallPositiveInteger
	^ self getSmallInteger! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:30'!
decodeSymbol
	^ self decodeUtf8String asSymbol! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:12'!
decodeUtf16String
	| size |
	size := materializer materialize.
	^ self getUtf16StringOfSize: size.
	! !

!SMDecoder methodsFor: 'decoding - base' stamp: 'cwp 8/26/2010 13:11'!
decodeUtf8String
	| size |
	size := materializer materialize.
	^ self getUtf8StringOfSize: size! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:30'!
getByte
	^ stream next! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:50'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream next ]! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream next].
	^ value! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:46'!
getSmallInteger
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) + lo! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:45'!
getType
	^ stream next! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!SMDecoder methodsFor: 'initialize-release' stamp: 'cwp 8/25/2010 21:41'!
initializeWithMaterializer: aMaterializer stream: aStream
	materializer := aMaterializer.
	stream := aStream.! !

!SMDecoder methodsFor: 'public' stamp: 'cwp 8/25/2010 21:47'!
materializer
	^ materializer! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:39'!
readTwoBytes
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) bitOr: lo! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!SMDecoder methodsFor: 'private' stamp: 'cwp 9/9/2008 08:00'!
readUtf8Character
	| value |
	value := stream next.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream next bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream next bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream next bitAnd: 63)].
			^ Unicode value: value ]! !

Object subclass: #SMEncoder
	instanceVariableNames: 'serializer stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

SMEncoder class
	instanceVariableNames: 'stream'!

SMEncoder class
	instanceVariableNames: 'stream'!

!SMEncoder class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 16:25'!
serializer: aSerializer stream: aStream
	^ self basicNew
		initializeWithSerializer: aSerializer stream: aStream;
		yourself! !

!SMEncoder methodsFor: 'public' stamp: 'cwp 8/26/2010 10:33'!
encode: anObject
	anObject encodeWith: self! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 19:41'!
encodeArray: anArray
	self writeLibraryType.
	self writeArrayType.
	self serializer serialize: anArray size! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 18:33'!
encodeArrow: anArrow
	self writeArrowType.
	self serializer serialize: anArrow index! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:39'!
encodeBytesFrom: anObject
	1 to: anObject byteSize do: 
		[:index | stream nextPut: (anObject byteAt: index)]! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:39'!
encodeClass: aClass
	self writeClassType.
	self serializer serialize: aClass name! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 19:33'!
encodeContext: aContext
	self writeType: 21.
	self serializer serialize: aContext method! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 20:17'!
encodeDictionary: aDictionary
	self writeLibraryType.
	self writeDictionaryType.
	self serializer serialize: aDictionary size! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:39'!
encodeExternal: anInteger
	self writeExternalType.
	self serializer serialize: anInteger! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:39'!
encodeFloat: aFloat
	self writeFloatType.
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2)! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 20:27'!
encodeInteger: anInteger
	anInteger < -65535 ifTrue: 
		[self writeLargeNegativeIntegerType.
		^ self writeLargeInteger: anInteger negated].
	anInteger < 0 ifTrue: 
		[self writeSmallNegativeIntegerType.
		^ self writeSmallInteger: anInteger negated].
	anInteger < 242 ifTrue: 
		[ ^ self writeTinyInteger: anInteger ].
	anInteger < 65535 ifTrue: 
		[self writeSmallPositiveIntegerType.
		^ self writeSmallInteger: anInteger].
	self writeLargePositiveIntegerType.
	self writeLargeInteger: anInteger! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:40'!
encodeObject: anObject
	self writeObjectType.
	self serializer serialize: anObject class.
	anObject class isVariable
		ifTrue: [ self serializer serialize: anObject size ]! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 20:17'!
encodeSet: aSet
	self writeLibraryType.
	self writeSetType.! !

!SMEncoder methodsFor: 'encoding - library' stamp: 'cwp 8/26/2010 20:07'!
encodeSingleton: aBoolean
	| index |
	self writeLibraryType.
	index := #(nil true false) indexOf: aBoolean.
	stream nextPut: index! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:40'!
encodeSymbol: aSymbol
	self writeSymbolType.
	self serializer serialize: aSymbol size.
	self writeUtf8String: aSymbol! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:40'!
encodeUtf16String: aString
	self writeUtf16Type.
	self serializer serialize: aString size.
	self writeUtf16String: aString! !

!SMEncoder methodsFor: 'encoding - base' stamp: 'cwp 8/26/2010 19:40'!
encodeUtf8String: aString
	self writeUtf8Type.
	self serializer serialize: aString size.
	self writeUtf8String: aString! !

!SMEncoder methodsFor: 'initialize-release' stamp: 'cwp 8/25/2010 16:25'!
initializeWithSerializer: aSerializer stream: aStream
	serializer := aSerializer.
	stream := aStream! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 16:30'!
serializer
	^ serializer! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 20:18'!
write32BitInteger: anInteger
	stream		
		nextPut: (anInteger bitShift: -24);
		nextPut: ((anInteger bitShift: -16) bitAnd: 255);
		nextPut: ((anInteger bitShift: -8) bitAnd: 255);
		nextPut: (anInteger bitAnd: 255)! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:13'!
writeArrayType
	stream nextPut: 4! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:39'!
writeArrowType
	stream nextPut: 255! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:13'!
writeBagType
	stream nextPut: 5! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:13'!
writeByteArrayType
	stream nextPut: 6! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:40'!
writeClassType
	stream nextPut: 253! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:43'!
writeCustomType
	stream nextPut: 242! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:13'!
writeDictionaryType
	stream nextPut: 7! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:40'!
writeExternalType
	stream nextPut: 254! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:42'!
writeFloatType
	stream nextPut: 244! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:28'!
writeFourByteCode: anInteger
	| value |
	value := 16r10000 - anInteger.
	stream nextPut: ((value bitShift: -18) bitOr: 16rD8).
	stream nextPut: ((value bitShift: -10) bitAnd: 16rFF).
	stream nextPut: ((value bitShift: -8) bitOr: 16rDC).
	stream nextPut: (value bitAnd: 16rFF).
	

! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:14'!
writeIdentityDictionaryType
	stream nextPut: 8! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:14'!
writeIntervalType
	stream nextPut: 9! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/26/2010 20:24'!
writeLargeInteger: anInteger
	| byte size |
	size := (anInteger log: 256) floor + 1.
	self serializer serialize: size.
	(size - 1 to: 0 by: -1)
		do: [ :index | 
			byte := (anInteger bitShift: index * -8) bitAnd: 255.
			stream nextPut: byte ]! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:41'!
writeLargeNegativeIntegerType
	stream nextPut: 248! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:42'!
writeLargePositiveIntegerType
	stream nextPut: 245! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:43'!
writeLibraryType
	stream nextPut: 243! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:40'!
writeObjectType
	stream nextPut: 252! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:14'!
writeOrderedCollectionType
	stream nextPut: 10! !

!SMEncoder methodsFor: 'types - library' stamp: 'cwp 8/26/2010 20:18'!
writeSetType
	stream nextPut: 11! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:06'!
writeSmallInteger: anInteger
	stream nextPut: (anInteger bitShift: -8).
	stream nextPut: (anInteger bitAnd: 255). ! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:42'!
writeSmallNegativeIntegerType
	stream nextPut: 247! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:42'!
writeSmallPositiveIntegerType
	stream nextPut: 246! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:41'!
writeSymbolType
	stream nextPut: 249! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/26/2010 19:38'!
writeTinyInteger: anInteger
	stream nextPut: anInteger! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:27'!
writeTwoByteCode: value
	stream nextPut: (value bitShift: -8).
	stream nextPut: (value bitAnd: 16rFF).! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/25/2010 17:17'!
writeType: aByte
	stream nextPut: aByte! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:07'!
writeUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:41'!
writeUtf16Type
	stream nextPut: 250! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:23'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream nextPut: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream nextPut: ((value bitShift: -6) bitOr: 16rC0).
					stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream nextPut: ((value bitShift: -12) bitOr: 16rE0).
							stream nextPut: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

!SMEncoder methodsFor: 'private' stamp: 'cwp 8/25/2010 17:06'!
writeUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

!SMEncoder methodsFor: 'types - base' stamp: 'cwp 8/26/2010 18:40'!
writeUtf8Type
	stream nextPut: 251! !

Object subclass: #SMIndex
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

SMIndex subclass: #SMArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMArrow methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:36'!
encodeWith: anEncoder
	anEncoder encodeArrow: self! !

!SMArrow methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 12:05'!
materializeWith: aMaterializer
	^ aMaterializer materializeArrow: self! !

SMIndex subclass: #SMExternal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMExternal methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:39'!
encodeWith: anEncoder
	anEncoder encodeExternal: self! !

!SMExternal methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 12:44'!
materializeWith: aMaterializer
	^ aMaterializer materializeExternal: self! !

!SMIndex class methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
with: anInteger
	^ self basicNew
		initializeWithIndex: anInteger;
		yourself! !

!SMIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
encodeWith: anEncoder
	self subclassResponsibility! !

!SMIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
index
	^ index! !

!SMIndex methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:38'!
initializeWithIndex: anInteger
	self initialize.
	index := anInteger.
	! !

Object subclass: #SMMaterializer
	instanceVariableNames: 'decoder internal external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:57'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!SMMaterializer class methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 14:19'!
on: aReadStream
	^ self basicNew
		initializeWithStream: aReadStream;
		yourself! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 8/26/2010 10:03'!
addArrow: anObject
	internal add: anObject! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 8/26/2010 10:04'!
external: anArray 
	
	external := anArray! !

!SMMaterializer methodsFor: 'initialize-release' stamp: 'cwp 8/26/2010 14:18'!
initializeWithStream: aStream 
	self initialize.
	decoder := SMDecoder materializer: self stream: aStream.
	internal := OrderedCollection new.
! !

!SMMaterializer methodsFor: 'public' stamp: 'cwp 8/26/2010 12:24'!
materialize
	| object |
	object := decoder decode.
	
	^ object materializeWith: self.
	! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:29'!
materializeArray: array
	self addArrow: array.
	self readPointersInto: array.
	^ array! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:06'!
materializeArrow: anArrow
	^ internal at: anArrow index! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:39'!
materializeClass: aClass
	self addArrow: aClass.

	"consume the inst var names"
	self materialize timesRepeat: [ self materialize ].
	
	^ aClass
	! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:55'!
materializeContext: aContext
	| sender pc stackp closure receiver |
	self addArrow: aContext.
	sender := self materialize.
	pc := self materialize.
	stackp := self materialize.
	closure := self materialize.
	receiver := self materialize.
	aContext
		setSender: sender
			receiver: receiver
			method: aContext method
			arguments: #() ;
		pc: pc ;
		stackp: stackp ;
		closure: closure.
	self readPointersInto: aContext.
	^ aContext! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:41'!
materializeDictionary: aDictionary
	| size |
	self addArrow: aDictionary.
	size := self materialize.
	size timesRepeat: 
		[ aDictionary 
			at: self materialize
			put: self materialize ].
	^ aDictionary! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:44'!
materializeExternal: anExternal
	^ external at: anExternal index! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 14:16'!
materializeObject: anObject
	1 to: anObject class instSize do: 
		[ : i | anObject instVarAt: i put: self materialize ].
	anObject class isVariable ifTrue: 
		[ anObject class isPointers 
			ifTrue: [ self readPointersInto: anObject ]
			ifFalse: [ decoder getBytesInto: anObject ] ].
	^ anObject! !

!SMMaterializer methodsFor: 'materializing' stamp: 'cwp 8/26/2010 12:28'!
materializeSet: aSet
	| size |
	self addArrow: aSet.
	size := self materialize.
	size timesRepeat: [ aSet add: self materialize ].
	^ aSet! !

!SMMaterializer methodsFor: 'private' stamp: 'cwp 9/3/2008 19:43'!
readPointersInto: anObject 
	
	1	to: anObject size
		do:	[ :i | anObject at: i put: self materialize ]! !

Object subclass: #SMObjectWithExternalState
	instanceVariableNames: 'alpha beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEm-Tests'!

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
alpha
	^ alpha! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
beta
	^ beta! !

!SMObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 8/26/2010 10:19'!
initialize
	alpha := ValueHolder new
		contents: 'alpha';
		yourself.
	
	beta := SMReference new
		value: 'beta';
		yourself! !

Object subclass: #SMReference
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMReference class methodsFor: 'as yet unclassified' stamp: 'cwp 8/25/2010 10:40'!
to: anObject
	^ self new
		value: anObject;
		yourself! !

!SMReference methodsFor: 'serialization' stamp: 'cwp 8/26/2010 10:14'!
serializeWith: aSerializer
	^ aSerializer serializeReference: self! !

!SMReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:38'!
value
	^ value! !

!SMReference methodsFor: 'accessing' stamp: 'cwp 8/25/2010 10:40'!
value: anObject
	^ value := anObject! !

Object subclass: #SMSerializer
	instanceVariableNames: 'encoder external internal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EsAndEM-Core'!

!SMSerializer class methodsFor: 'instance creation' stamp: 'cwp 8/26/2010 14:19'!
on: aWriteStream
	^ self new 
		initializeWithStream: aWriteStream;
		yourself! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/23/2010 12:17'!
serialize: anObject
	| ext stream |
	stream := (ByteArray new: 100) writeStream.
	ext := SMSerializer serialize: anObject on: stream.
	ext isEmpty ifFalse: [self error: 'This object refers to unserializable objects'].
	^ stream contents! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject external: aDictionary
	| stream external |
	stream := (ByteArray new: 100) writeStream.
	external := self serialize: anObject external: aDictionary on: stream.
	^ SMArchive bytes: stream contents external: external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject external: aDictionary on: aWriteStream
	^ (self on: aWriteStream)
		external: aDictionary;
		serialize: anObject;
		external! !

!SMSerializer class methodsFor: 'serializing' stamp: 'cwp 8/26/2010 09:59'!
serialize: anObject on: aWriteStream
	^ self 
		serialize: anObject 
		external: IdentityDictionary new 
		on: aWriteStream! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/26/2010 09:58'!
external
	| array |
	array := Array new: external size.
	external keysAndValuesDo:
		[:object :i | array at: i put: object].
	^ array! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/26/2010 09:58'!
external: aDictionary
	external := aDictionary! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/25/2010 16:55'!
indexOf: anObject in: anIndex do: aBlock
	^ self indexOf: anObject in: anIndex ifPresent: aBlock ifAbsent: aBlock! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:03'!
indexOf: anObject in: anIndex ifPresent: pBlock ifAbsent: aBlock
	| id |
	(anIndex includesKey: anObject)
		ifTrue: 
			[id := anIndex at: anObject.
			pBlock value: id]
		ifFalse:
			[id := anIndex size + 1.
			anIndex at: anObject put: id.
			aBlock value: id].
	
		! !

!SMSerializer methodsFor: 'initialize-release' stamp: 'cwp 8/26/2010 14:18'!
initializeWithStream: aWriteStream 
	encoder := SMEncoder serializer: self stream: aWriteStream.
	internal := IdentityDictionary new.
	external := IdentityDictionary new.
! !

!SMSerializer methodsFor: 'public' stamp: 'cwp 8/31/2008 21:21'!
serialize: anObject
	anObject serializeWith: self! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/26/2010 10:36'!
serialize: anObject with: aBlock
	self
		indexOf: anObject
		in: internal
		ifPresent: [ :id | encoder encode: (SMArrow with: id) ]
		ifAbsent: [ :id | aBlock value ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 14:20'!
serializeArray: anArray
	self serialize: anArray with: 
		[encoder encodeArray: anArray.
		anArray do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 11:39'!
serializeClass: aClass
	| vars |
	self serialize: aClass with: 
		[encoder encodeClass: aClass.
		vars := aClass allInstVarNames.
		self serialize: vars size.
		vars do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 11:40'!
serializeDictionary: aDictionary
	self serialize: aDictionary with: 
		[encoder encodeDictionary: aDictionary.
		aDictionary keys asArray sort do: 
			[ :key | 
			self serialize: key.
			self serialize: (aDictionary at: key) ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 11:40'!
serializeExternal: anObject
	self 
		indexOf: anObject 
		in: external 
		do: [ :index | encoder encodeExternal: index ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:46'!
serializeFloat: aFloat
	encoder encodeFloat: aFloat! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:42'!
serializeInteger: anInteger
	encoder encodeInteger: anInteger! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 17:16'!
serializeMethodContext: aContext
	self serialize: aContext with: 
		[encoder encodeContext: aContext.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext stackPtr.
		self serialize: aContext closure.
		self serialize: aContext receiver.
		self writePointersFrom: aContext ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 11:42'!
serializeObject: anObject
	self serialize: anObject with: 
		[encoder encode: anObject.
		1 to: anObject class instSize do: [ :i | self serialize: (anObject instVarAt: i) ].
		anObject class isVariable ifTrue: 
			[anObject class isPointers
				ifTrue: [ self writePointersFrom: anObject ]
				ifFalse: [ encoder encodeBytesFrom: anObject ] ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 10:26'!
serializeReference: aReference
	encoder encodeObject: aReference.
	self serializeExternal: aReference value! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/26/2010 12:30'!
serializeSet: aSet
	self serialize: aSet with: 
		[encoder encodeSet: aSet.
		self serialize: aSet size.
		aSet do: [ :ea | self serialize: ea ] ]! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:57'!
serializeSingleton: aBoolean
	encoder encodeSingleton: aBoolean! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:58'!
serializeSymbol: aSymbol
	encoder encodeSymbol: aSymbol! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 17:00'!
serializeUtf16String: aString
	encoder encodeUtf16String: aString! !

!SMSerializer methodsFor: 'serializing' stamp: 'cwp 8/25/2010 16:59'!
serializeUtf8String: aString
	encoder encodeUtf8String: aString! !

!SMSerializer methodsFor: 'private' stamp: 'cwp 8/25/2010 11:18'!
writePointersFrom: anObject
	1 to: anObject size do: [ :i | self serialize: (anObject at: i)]! !

!Class methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:36'!
materializeWith: aMaterializer
	^ aMaterializer materializeClass: self! !

!Class methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 23:04'!
serializeWith: aSerializer
	aSerializer serializeClass: self! !

!ByteString methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 21:49'!
serializeWith: aSerializer
	aSerializer serializeUtf8String: self! !

!WideString methodsFor: '*esandem-dispatch' stamp: 'cwp 8/31/2008 21:49'!
serializeWith: aSerializer
	aSerializer serializeUtf16String: self! !

!Array methodsFor: '*esandem-dispatching' stamp: 'cwp 8/26/2010 12:06'!
materializeWith: aMaterializer
	^ aMaterializer materializeArray: self! !

!Array methodsFor: '*esandem-dispatching' stamp: 'cwp 9/2/2008 00:25'!
serializeWith: aSerializer
	aSerializer serializeArray: self! !

!Set methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:25'!
materializeWith: aMaterializer
	aMaterializer materializeSet: self! !

!Set methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 12:24'!
serializeWith: aSerializer
	^ aSerializer serializeSet: self! !

!UndefinedObject methodsFor: '*esandem-dispatch' stamp: 'cwp 8/26/2010 13:09'!
materailizeWith: aMaterializer
	^ self! !

!UndefinedObject methodsFor: '*esandem-dispatch' stamp: 'cwp 9/1/2008 19:36'!
serializeWith: aSerializer
	^ aSerializer serializeSingleton: self! !
